#!/sw/bin/perl

use Date::Calc qw(Today Month_to_Text);

$self = $0;
$self =~ s!^.*/!!;

#undef $/;

@files = qw
(
    Makefile.PL
    build
    build.pod
    genopt
    genopt.pod
    genopt.txt
    BnP.pm
    perl.bnp
    sfio.bnp
    gimp.bnp
    imagick.bnp
    tools.bnp
);

@files = map(($_, "bak/$_"), @files);

($year,$month,$day) = Today();

$date = sprintf("%02d-%.3s-%d", $day, Month_to_Text($month), $year);

unless (chdir("/Modules"))
{
    die "$self: can't chdir to '/Modules': $!\n";
}

unless (-l "current")
{
    die "$self: symbolic link 'current' does not exist!\n";
}

$current = readlink("current");

unless ($current =~ /(\d+)\.(\d+)\.(\d+)$/)
{
    die "$self: can't extract the version number from '$current'!\n";
}

($version,$level,$patch) = ($1,$2,$3);

unless (chdir("current"))
{
    die "$self: can't chdir to 'current': $!\n";
}

FILE:
foreach $filename (@files)
{
    next FILE unless (-f $filename);
    unless (open(INPUT, "<$filename"))
    {
        warn "unable to read '$filename': $!\n";
        next FILE;
    }
    unless (rename($filename,"$filename.bak"))
    {
        warn "unable to rename '$filename' to '$filename.bak': $!\n";
        next FILE;
    }
    unless (open(OUTPUT, ">$filename"))
    {
        warn "unable to write '$filename': $!\n";
        next FILE;
    }
    print "Updating '$filename'...\n";
    while (<INPUT>)
    {
        s![ \t]+$!!;
        s!(["']?version["']?\s*(?:=>|,)\s*["']?)\s*\d+\.\d+\.\d+\s*(["']?)!${1}${version}.${level}.${patch}${2}!i;
        s!(version\s*=\s*["']\s*)\d+\.\d+\.\d+(\s+)\(\d{2}-[a-z]{3}-\d{4}\)!${1}${version}.${level}.${patch}${2}(${date})!i;
        s!(\s["']?genopt["']?\s+version\s+)\d+\.\d+\.\d+,!${1}${version}.${level}.${patch},!i;
        s!(This\s+man[\s-]?page\s+documents.+version\s+)\d+\.\d+\.\d+\.$!${1}${version}.${level}.${patch}.!i;
        print OUTPUT;
    }
    close(INPUT);
    close(OUTPUT);
    if ($filename =~ /\./) { chmod(0444, $filename); }
    else                   { chmod(0555, $filename); }
}

